<?php

class WFilterNGF
{

	private $session_id = "00000000000000000000000000000000";
	private $cmd_id = 1;
	private $server;
	
	//core rpc call function.
	private function rpc_call( $object, $method, $para, &$msg ){
		$ret = false;
		$headers = array();
		$headers[] = 'Content-Type: application/json';

		$ch = curl_init( $this->server . "/ubus" );

		curl_setopt( $ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
		curl_setopt( $ch, CURLOPT_CONNECTTIMEOUT, 20 );
		curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers );
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

		$post_data = "{\"jsonrpc\":\"2.0\","
			. "\"id\":" . $this->cmd_id++ . ",
			\"method\":\"call\",
			\"params\":[ \"" . $this->session_id . "\", \"" . $object . "\", \"" . $method . "\"," . $para . " ]}";

		curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data );
		$res = curl_exec($ch);
		if( !($res)) {
			$errno = curl_errno($ch);
			$errstr = curl_error($ch);
		}else{
			$msg = $res;
			$ret = true;
		}
		curl_close($ch);
		return $ret;
	}
	
	//Login
	public function login( $server, $username, $password ){
		$msg = "";
		$data = "{\"username\":\"" . $username . "\",\"password\":\"" . md5($password) . "\"}";
		$this->server = $server;
		if( $this->rpc_call( "session", "login", $data, $msg )){
			$findme = "\"ubus_rpc_session\":\"";
			$pos = strpos( $msg, $findme );
			if( $pos ){
				$this->session_id = substr( $msg, $pos+strlen($findme), 32 );
				//echo "session_id=" . $this->session_id . "<br>";
				return true;
			}
		}
		return false;
	}
	//Logout
	public function logout(){
		$msg = "";
		$this->rpc_call( "session", "destroy", "", $msg );
	}
	//renew_user: extend user expire data of "Accounts".
	public function renew_user( $userid, $newdate ){
		$msg = "";
		$data = "{\"data\":\"wfilter-isp renew " . $userid . " " . $newdate . "\"}";
		if( $this->rpc_call( "wfilter", "exec", $data, $msg )){
			if( strpos( $msg, $newdate ) != FALSE ){
				return true;
			}
		}
		return false;
	}
	//add_virtual_group: add IP/user into a virtual group for N minutes.
	public function add_virtual_group( $groupid, $ip, $minutes ){
		$msg = "";
		$data = "{\"id\":\"" . $groupid . "\",\"ip\":\"" . $ip . "\",\"minute\":\"" . $minutes . "\"}";
		if( $this->rpc_call( "wfilter", "add-virtual-group", $data, $msg )){
			if( strpos( $msg, "0000" ) != FALSE ){
				return true;
			}
		}
		return false;
	}
	//rm_virutal_group: remove IP/user from a virtual group.
	public function rm_virtual_group( $ip ){
		$msg = "";
		$data = "{\"data\":\"" . $ip . "\"}";
		if( $this->rpc_call( "wfilter", "rm-virtual-group", $data, $msg )){
			if( strpos( $msg, "0000" ) != FALSE ){
				return true;
			}
		}
		return false;
	}
	//Get groups list.
	public function list_group(){
		$msg = "";
		$data = "{\"config\":\"wfilter-groups\"}";
		$this->rpc_call( "uci", "get", $data, $msg );
		return $msg;
	}
	//Get account list.
	public function list_account(){
		$msg = "";
		$data = "{\"config\":\"wfilter-account\"}";
		$this->rpc_call( "uci", "get", $data, $msg );
		return $msg;
	}
	//Get bandwidth history of past N seconds
	public function list_bandwidth( $seconds ){
		$msg = "";
		$data = "{\"data\":\"" . $seconds . "\"}";
		$this->rpc_call( "wfilter", "list-bandwidth", $data, $msg );
		return $msg;
	}
	/*List online devices.
	 * top: rows to be returned, maxium 1000.
	 * search: search by username, ip or mac
	 */
	public function list_online_users( $top, $search ){
		$msg = "";
		$data = "{\"row\":\"" . $top . "\", \"search\":\"" . $search ."\"}";
		$this->rpc_call( "wfilter", "get-top-bandwidth", $data, $msg );
		return $msg;
	}
	//List online connections of a client
	public function list_online_connections( $ip ){
		$msg = "";
		$data = "{\"data\":\"" . $ip . "\"}";
		$this->rpc_call( "wfilter", "get-links", $data, $msg );
		return $msg;
	}
	/* Terminate connections(kick off user)
	 * port -- connection local port, 0 for all ports
	 * type -- "ALL"-- all protocols, "RESET"-- reset to default, "REMOVE"-- bypass all blocking, others -- protocol name.
	 * minutes -- blocking minutes
	 * message -- message to be displayed(urlencoded)
	 */
	public function kill_connection( $ip, $port, $type, $minutes, $message ){
		$msg = "";
		$data = "{\"ip\":\"" . $ip . "\",\"port\":\"" . $port . "\",\"proto\":\"". $type . "\",\"minutes\":\"". $minutes . "\",\"message\":\"". $message . "\"}";
		if( $this->rpc_call( "wfilter", "kill-link", $data, $msg )){
			if( strpos( $msg, "0000" ) != FALSE ){
				return true;
			}
		}
		return false;
	}
	/* List network interfaces */
	public function get_network_interfaces(){
		$msg = "";
		$this->rpc_call( "network.interface", "dump", "{}", $msg );
		return $msg;
	}
	/* Get interface status and statistics */
	public function get_network_status(){
		$msg = "";
		$this->rpc_call( "network.device", "status", "{}", $msg );
		return $msg;
	}
	/* Connect IP with username
	 * user: username(urlencoded)
	 * from: from type(eg: webauth, pppoe)
	 * expire: expire after N seconds
	*/
	public function add_user( $ip, $user, $from, $expire ){
		$msg = "";
		$data = "{\"ip\":\"" . $ip . "\",\"user\":\"" . $user . "\",\"from\":\"". $from . "\",\"expire\":\"". $expire . "\"}";
		if( $this->rpc_call( "wfilter", "add-user", $data, $msg )){
			if( strpos( $msg, "0000" ) != FALSE ){
				return true;
			}
		}
		return false;
	}
	/* Disconnect ip with username
	 * Parameter: ip or username(urlencoded)
	*/
	public function rm_user( $user ){
		$msg = "";
		$data = "{\"data\":\"" . $user . "\"}";
		if( $this->rpc_call( "wfilter", "rm-user", $data, $msg )){
			if( strpos( $msg, "0000" ) != FALSE ){
				return true;
			}
		}
		return false;
	}
	//Get settings
	public function config_load( $cfgname ){
		$msg = "";
		$data = "{\"config\":\"" . $cfgname . "\"}";
		$this->rpc_call( "uci", "get", $data, $msg );
		return $msg;
	}
	//Add settings
	public function config_add( $cfgname, $type, $name, $values ){
		$msg = "";
		$data = "{\"config\":\"" . $cfgname . "\",\"type\":\"" . $type . "\",\"name\":\"" . $name . "\",\"values\":" . $values . "}";
		$this->rpc_call( "uci", "add", $data, $msg );
		return $msg;
	}
	//Modify settings
	public function config_set( $cfgname, $section, $values ){
		$msg = "";
		$data = "{\"config\":\"" . $cfgname . "\",\"section\":\"" . $section . "\",\"values\":" . $values . "}";
		$this->rpc_call( "uci", "set", $data, $msg );
		return $msg;
	}
	//Delete settings
	public function config_del( $cfgname, $section ){
		$msg = "";
		$data = "{\"config\":\"" . $cfgname . "\",\"section\":\"" . $section . "\"}";
		$this->rpc_call( "uci", "delete", $data, $msg );
		return $msg;
	}
	//Apply changes
	public function config_apply(){
		$msg = "";
		$data = "{\"data\":\"busybox sh /usr/sbin/wfilter-apply\"}";
		$this->rpc_call( "wfilter", "exec", $data, $msg );
		return $msg;
	}
}

?>
